#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#define MAXS 250
char w[MAXS];
#define LIST 10
char res[LIST][MAXS];
int points[LIST];

int score[26]={
	1,	/* A */
	5,	/* B */
	2,	/* C */
	3,	/* D */
	1,	/* E */
	5,	/* F */
	4,	/* G */
	4,	/* H */
	1,	/* I */
	15,	/* J */
	6,	/* K */
	2,	/* L */
	4,	/* M */
	1,	/* N */
	1,	/* O */
	3,	/* P */
	15,	/* Q */
	2,	/* R */
	1,	/* S */
	1,	/* T */
	3,	/* U */
	6,	/* V */
	5,	/* W */
	10,	/* X */
	5,	/* Y */
	12	/* Z */
};

int main(int argc,char **argv) {
	int i;
	int f[26],g[26],maks,pt;
	char fmt[250],c;
	FILE *F;
	if(argc<3) {
		puts("quarrel solver by ruben spaans in july 2012");
		puts("usage: quarrel letters max-word-size");
		return 0;
	}
	for(i=0;i<LIST;i++) points[i]=-1;
	if(strlen(argv[1])>=MAXS) {
		puts("error, too many letters");
		return 0;
	}
	F=fopen("words-en.txt","r");
	if(!F) {
		puts("error, couldn't open words-en.txt, the dictionary file.");
		return 0;
	}
	maks=strtol(argv[2],0,10);
	if(maks<1) {
		puts("need at least 1 letter in destination word");
		return 0;
	}
	sprintf(fmt,"%%%ds\n",MAXS-1);
	for(i=0;i<26;i++) f[i]=0;
	for(i=0;argv[1][i];i++) {
		c=toupper(argv[1][i]);
		if(c<'A' || c>'Z') {
			puts("illegal letter in letters");
			return 0;
		}
		f[c-'A']++;
	}
	while(fscanf(F,fmt,w)==1) if(strlen(w)<=maks) {
		for(i=0;i<26;i++) g[i]=0;
		for(pt=i=0;w[i];i++) {
			c=toupper(w[i]);
			if(c<'A' || c>'Z') goto next;
			g[w[i]-'A']++;
			pt+=score[w[i]-'A'];
		}
		for(i=0;i<26;i++) if(g[i]>f[i]) goto next;
		i=LIST-1;
		while(i>=0 && points[i]<pt) {
			if(i<LIST-1) points[i+1]=points[i],strcpy(res[i+1],res[i]);
			i--;
		}
		i++;
		strcpy(res[i],w);
		points[i]=pt;
	next:;
	}
	fclose(F);
	for(i=0;i<LIST && points[i]>-1;i++) printf("%s %d\n",res[i],points[i]);
	return 0;
}
